	list p=16f648a
	#include "p16f648a.inc"
	__config	_BOREN_OFF & _CP_OFF & _DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTOSC_OSC_CLKOUT

PORTA_IR	equ	4
PORTA_RST	equ	1
PORTA_RX	equ	0
PORTA_TX	equ	7



work0	equ	0x20
work1	equ	0x21
work2	equ	0x22
txdata	equ	0x23


	org	0
	goto	init


wait100us
	movlw	0x18
	movwf	work0
wait100us_loop
	nop
	decfsz	work0, 1
	goto	wait100us_loop
	retlw	0

wait1ms
	movlw	0xf9
	movwf	work0
wait1ms_loop
	nop
	decfsz	work0, 1
	goto	wait1ms_loop
	retlw	0

wait250ms
	movlw	0xf9
	movwf	work1
wait250ms_loop
	call	wait1ms
	decfsz	work1, 1
	goto	wait250ms_loop
	retlw	0


waitrs					; 104us - 4
					; 2clk for call
	nop
	movlw	0x1f
	movwf	work0
waitrs0
	decfsz	work0, 1
	goto	waitrs0
	
	retlw	0			; 2clk for ret


waitrs2					; 52us - 4
	movlw	0xe
	movwf	work0
waitrs2_0
	decfsz	work0, 1
	goto	waitrs2_0
	
	retlw	0


sendrs_hex
	movwf	work1
	swapf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
	call	sendrs
	
	movf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
sendrs
	movwf	txdata
	bcf	PORTA, PORTA_TX		; start
	nop
	nop
	call	waitrs
	btfsc	txdata, 0		; LSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 0
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 1		; bit 1
	bsf	PORTA, PORTA_TX
	btfss	txdata, 1
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 2		; bit 2
	bsf	PORTA, PORTA_TX
	btfss	txdata, 2
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 3		; bit 3
	bsf	PORTA, PORTA_TX
	btfss	txdata, 3
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 4		; bit 4
	bsf	PORTA, PORTA_TX
	btfss	txdata, 4
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 5		; bit 5
	bsf	PORTA, PORTA_TX
	btfss	txdata, 5
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 6		; bit 6
	bsf	PORTA, PORTA_TX
	btfss	txdata, 6
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 7		; MSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 7
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	nop
	nop
	bsf	PORTA, PORTA_TX		; stop
	call	waitrs
	retlw	0


recvrs
	btfsc	PORTA, PORTA_RX		; wait start-bit
	goto	recvrs
	
	call	waitrs2
	nop				; center of start-bit
	nop
	nop
	clrf	work1
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 0
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 1
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 2
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 3
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 4
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 5
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 6
	nop
	nop
	
	call	waitrs
	btfsc	PORTA, PORTA_RX
	bsf	work1, 7
	
	retlw	0


init
	clrf	PORTA			; PORTA: 00000000
	clrf	PORTB			; PORTB: 00000000
	
	bsf	STATUS, RP0
	
	movlw	0x11			; PORTA: OOOIOOOI
	movwf	PORTA
	movlw	1
	movwf	PORTB			; PORTB: OOOOOOOI
	movlw	0			; RBPU
	movwf	OPTION_REG & 0x7f
	
	bcf	STATUS, RP0
	
	movlw	7			; PORTA: digital-input
	movwf	CMCON
	
	bcf	PORTA, PORTA_RST
	bsf	PORTA, PORTA_TX		; LED
	call	wait250ms
	bsf	PORTA, PORTA_RST
	
main
	call	recvrs
	call	waitrs
	movf	work1, 0
	xorlw	0xd
	btfss	STATUS, Z
	goto	main
	
	call	recvrs
	call	waitrs
	movf	work1, 0
	xorlw	0xa
	btfss	STATUS, Z
	goto	main
	
	call	recvrs
	call	waitrs
	movf	work1, 0
	xorlw	0xd
	btfss	STATUS, Z
	goto	main
	
	call	recvrs
	call	waitrs
	movf	work1, 0
	xorlw	0xa
	btfss	STATUS, Z
	goto	main
	
	movlw	0x48			; 'H'
	call	sendrs
	movlw	0x54			; 'T'
	call	sendrs
	movlw	0x54			; 'T'
	call	sendrs
	movlw	0x50			; 'P'
	call	sendrs
	movlw	0x2f			; '/'
	call	sendrs
	movlw	0x31			; '1'
	call	sendrs
	movlw	0x2e			; '.'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x20			; ' '
	call	sendrs
	movlw	0x32			; '2'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x20			; ' '
	call	sendrs
	movlw	0x4f			; 'O'
	call	sendrs
	movlw	0x4b			; 'K'
	call	sendrs
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	
	movlw	0x3c			; '<'
	call	sendrs
	movlw	0x48			; 'H'
	call	sendrs
	movlw	0x31			; '1'
	call	sendrs
	movlw	0x3e			; '>'
	call	sendrs
	movlw	0x74			; 't'
	call	sendrs
	movlw	0x65			; 'e'
	call	sendrs
	movlw	0x73			; 's'
	call	sendrs
	movlw	0x74			; 't'
	call	sendrs
	movlw	0x3c			; '<'
	call	sendrs
	movlw	0x2f			; '/'
	call	sendrs
	movlw	0x48			; 'H'
	call	sendrs
	movlw	0x31			; '1'
	call	sendrs
	movlw	0x3e			; '>'
	call	sendrs
	
	goto	main




	end
