	list p=16f648a
	#include "p16f648a.inc"
	__config	_BOREN_OFF & _CP_OFF & _DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTOSC_OSC_CLKOUT

PORTA_IR	equ	4
PORTA_RST	equ	1
PORTA_RX	equ	0
PORTA_TX	equ	7

PORTA_MMCCS	equ	2
PORTB_MMCDI	equ	3
PORTB_MMCCK	equ	2
PORTB_MMCDO	equ	0


work0	equ	0x20
work1	equ	0x21
work2	equ	0x22
txdata	equ	0x23

mmc_packet	equ	0x26		; - 0x2b
bitcount	equ	0x2c
bytecount	equ	0x2d

addr	equ	0x2e			; - 0x31: work address register
c_hsecp	equ	0x32			; log2 of half-sector(256 bytes)s per cluster
f_sec	equ	0x33			; sectors of FAT
remain_sec	equ	0x34		; remain sectors in cluster
cur_cluster	equ	0x35		; - 0x36: current cluster
rem_byte	equ	0x37		; - 0x38: remain bytes in sector(512 bytes)
fataddr	equ	0x39			; - 0x3c
useraddr	equ	0x3d		; - 0x40
rdeaddr	equ	0x41			; - 0x44


	org	0
	goto	init


wait100us
	movlw	0x18
	movwf	work0
wait100us_loop
	nop
	decfsz	work0, 1
	goto	wait100us_loop
	retlw	0

wait1ms
	movlw	0xf9
	movwf	work0
wait1ms_loop
	nop
	decfsz	work0, 1
	goto	wait1ms_loop
	retlw	0

wait250ms
	movlw	0xf9
	movwf	work1
wait250ms_loop
	call	wait1ms
	decfsz	work1, 1
	goto	wait250ms_loop
	retlw	0


waitrs					; 104us - 4
					; 2clk for call
	nop
	movlw	0x1f
	movwf	work0
waitrs0
	decfsz	work0, 1
	goto	waitrs0
	
	retlw	0			; 2clk for ret


sendrs_hex
	movwf	work1
	swapf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
	call	sendrs
	
	movf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
sendrs
	movwf	txdata
	bcf	PORTA, PORTA_TX		; start
	nop
	nop
	call	waitrs
	btfsc	txdata, 0		; LSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 0
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 1		; bit 1
	bsf	PORTA, PORTA_TX
	btfss	txdata, 1
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 2		; bit 2
	bsf	PORTA, PORTA_TX
	btfss	txdata, 2
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 3		; bit 3
	bsf	PORTA, PORTA_TX
	btfss	txdata, 3
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 4		; bit 4
	bsf	PORTA, PORTA_TX
	btfss	txdata, 4
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 5		; bit 5
	bsf	PORTA, PORTA_TX
	btfss	txdata, 5
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 6		; bit 6
	bsf	PORTA, PORTA_TX
	btfss	txdata, 6
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 7		; MSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 7
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	nop
	nop
	bsf	PORTA, PORTA_TX		; stop
	call	waitrs
	retlw	0


mmcstart
	bcf	PORTA, PORTA_MMCCS
	retlw	0


mmcstop
	bsf	PORTB, PORTB_MMCDI
	movlw	8
	movwf	bitcount
mmcstop_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	bitcount, 1
	goto	mmcstop_loop
	
	bsf	PORTA, PORTA_MMCCS
	
	movlw	8
	movwf	bitcount
mmcstop_loop2
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	bitcount, 1
	goto	mmcstop_loop2
	retlw	0


mmccmd
	movlw	6
	movwf	bytecount
	movlw	mmc_packet
	movwf	FSR
mmccmd_loop
	movf	INDF, 0
	call	mmcwrite
	
	incf	FSR, 1
	decfsz	bytecount, 1
	goto	mmccmd_loop
mmccmd_loop2
	call	mmcread
	btfsc	mmc_packet, 7
	goto	mmccmd_loop2
	retlw	0			; card ready


waitread			; wait for data-packet start byte
waitread_loop
	call	mmcread
	
	movf	mmc_packet, 0
	xorlw	0xff
	btfsc	STATUS, Z
	goto	waitread_loop		; card busy
	
	movf	mmc_packet, 0
	xorlw	0xfe			; data-start
	btfss	STATUS, Z
	goto	waitread_loop
	retlw	0


waitwrite
waitwrite_loop
	call	mmcread
	movf	mmc_packet, 0
	andlw	0x1f
	xorlw	5
	btfss	STATUS, Z		; data-packet receive complete
	goto	waitwrite_loop
waitwrite_loop2
	call	mmcread
	movf	mmc_packet, 0
	btfsc	STATUS, Z
	goto	waitwrite_loop2		; card busy
	
	retlw	0


mmcread
	movlw	8
	movwf	bitcount
mmcread_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bcf	STATUS, C
	btfsc	PORTB, PORTB_MMCDO
	bsf	STATUS, C
	
	rlf	mmc_packet, 1
	
	decfsz	bitcount, 1
	goto	mmcread_loop
	
	retlw	0


mmcwrite
	movwf	mmc_packet
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 7
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 6
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 5
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 4
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 3
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 2
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 1
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 0
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	retlw	0


displayerror
	movwf	work2
	movlw	0x6e		; 'e'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x6f		; 'o'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x2e		; '-'
	call	sendrs
	movf	work2, 0
	call	sendrs_hex
	movlw	0xd			; CR
	call	sendrs
	movlw	0xa			; LF
	call	sendrs
	
displayerror_halt
	goto	displayerror_halt


init
	clrf	PORTA			; PORTA: 00000000
	clrf	PORTB			; PORTB: 00000000
	
	bsf	STATUS, RP0
	
	movlw	0x11			; PORTA: OOOIOOOI
	movwf	PORTA
	movlw	1
	movwf	PORTB			; PORTB: OOOOOOOI
	movlw	0			; RBPU
	movwf	OPTION_REG & 0x7f
	
	bcf	STATUS, RP0
	
	movlw	7			; PORTA: digital-input
	movwf	CMCON
	
	bsf	PORTA, PORTA_MMCCS
	bsf	PORTB, PORTB_MMCDI
	bsf	PORTB, PORTB_MMCCK
	
	bcf	PORTA, PORTA_RST
	bsf	PORTA, PORTA_TX		; LED
	call	wait250ms
	bsf	PORTA, PORTA_RST
	
main
	movlw	0x28
	movwf	work2
wait10s
	call	wait250ms
	decfsz	work2, 1
	goto	wait10s
	
	movlw	0x62			; b
	call	sendrs
	movlw	0x6f			; o
	call	sendrs
	movlw	0x6f			; o
	call	sendrs
	movlw	0x74			; t
	call	sendrs
	movlw	0xd			; CR
	call	sendrs
	movlw	0xa			; LF
	call	sendrs
	
	clrf	mmc_packet
	clrf	mmc_packet + 1
	clrf	mmc_packet + 2
	clrf	mmc_packet + 3
	clrf	mmc_packet + 4
	clrf	mmc_packet + 5
	
reset0
	movlw	0x50			; reset : 80clk
	movwf	work0
reset0_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	work0, 1
	goto	reset0_loop
	
	call	mmcstart
	movlw	0x40			; cmd0
	movwf	mmc_packet
	movlw	0x95			; crc
	movwf	mmc_packet + 5
	call	mmccmd
	movlw	0xff
	movwf	mmc_packet + 5
	call	mmcstop
	
	movf	mmc_packet, 0
	xorlw	1
	movlw	0x11			; cmd0 failed
	btfss	STATUS, Z
	goto	displayerror
reset1
	call	wait250ms
	
	call	mmcstart
	movlw	0x41			; cmd1
	movwf	mmc_packet
	call	mmccmd
	call	mmcstop
	
	movf	mmc_packet, 0
	xorlw	1			; 1: card busy
	btfsc	STATUS, Z
	goto	reset1
	
	movf	mmc_packet, 0
	movlw	0x12			; cmd1 failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcstart
	movlw	0x50			; set_blocklen
	movwf	mmc_packet
	clrf	mmc_packet + 1
	clrf	mmc_packet + 2
	movlw	2
	movwf	mmc_packet + 3		; 200h = 512bytes / sector
	clrf	mmc_packet + 4
	call	mmccmd
	clrf	mmc_packet + 3
	call	mmcstop
	
	movf	mmc_packet, 0
	movlw	0x13			; set_blocklen failed
	btfss	STATUS, Z
	goto	displayerror
	
getmbr
	call	mmcstart
	movlw	0x51			; read single block
	movwf	mmc_packet
	clrf	mmc_packet + 1		; MBR
	clrf	mmc_packet + 2
	clrf	mmc_packet + 3
	clrf	mmc_packet + 4
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	0x31			; MBR read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	clrf	work2			; read 512 bytes
getmbr_loop
	movf	work2, 0
	andlw	7
	btfss	STATUS, Z
	goto	getmbr_loop1
	
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	
getmbr_loop1
	call	mmcread
	movf	mmc_packet, 0
	call	sendrs_hex
	
	movlw	0x20			; ' '
	call	sendrs
	
	call	mmcread
	movf	mmc_packet, 0
	call	sendrs_hex
	
	movlw	0x20			; ' '
	call	sendrs
	
	decfsz	work2, 1
	goto	getmbr_loop
	
	call	mmcread			;CRC
	call	mmcread
	call	mmcstop
	
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	
halt0
	goto	halt0




	end
