	list p=16f648a
	#include "p16f648a.inc"
	__config	_BOREN_OFF & _CP_OFF & _DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTOSC_OSC_CLKOUT

PORTA_IR	equ	4
PORTA_RST	equ	1
PORTA_RX	equ	0
PORTA_TX	equ	7

PORTA_MMCCS	equ	2
PORTB_MMCDI	equ	3
PORTB_MMCCK	equ	2
PORTB_MMCDO	equ	0


work0	equ	0x20
work1	equ	0x21
work2	equ	0x22
txdata	equ	0x23
count	equ	0x24
crlf	equ	0x25

mmc_packet	equ	0x26		; - 0x2b
bitcount	equ	0x2c
bytecount	equ	0x2d

addr	equ	0x2e			; - 0x31: work address register
c_hsecp	equ	0x32			; log2 of half-sector(256 bytes)s per cluster
f_sec	equ	0x33			; sectors of FAT
remain_sec	equ	0x34		; remain sectors in cluster
cur_cluster	equ	0x35		; - 0x36: current cluster
rem_byte	equ	0x37		; - 0x38: remain bytes in sector(512 bytes)
fataddr	equ	0x39			; - 0x3c
useraddr	equ	0x3d		; - 0x40
rdeaddr	equ	0x41			; - 0x44

rxphase	equ	0x45
rxwork	equ	0x46
rxdata	equ	0x47


	org	0
	goto	init


wait100us
	movlw	0x18
	movwf	work0
wait100us_loop
	nop
	decfsz	work0, 1
	goto	wait100us_loop
	retlw	0

wait1ms
	movlw	0xf9
	movwf	work0
wait1ms_loop
	nop
	decfsz	work0, 1
	goto	wait1ms_loop
	retlw	0

wait250ms
	movlw	0xf9
	movwf	work1
wait250ms_loop
	call	wait1ms
	decfsz	work1, 1
	goto	wait250ms_loop
	retlw	0


waitrs
	call	waitrs3
	
	btfsc	crlf, 2
	goto	waitrs_none
	btfsc	crlf, 0
	goto	waitrs_lf
	
				; crlf = 0, 2
	movf	rxdata, 0
	btfsc	STATUS, Z
	goto	waitrs_none
	
	incf	crlf, 1
	
	xorlw	0xd
	btfss	STATUS, Z
	clrf	crlf
	
	clrf	rxdata
	goto	waitrs_none
waitrs_lf
				; crlf = 1, 3
	movf	rxdata, 0
	btfsc	STATUS, Z
	goto	waitrs_none
	
	incf	crlf, 1
	
	xorlw	0xa
	btfss	STATUS, Z
	clrf	crlf
	
	clrf	rxdata
	
waitrs_none
	call	waitrs3
waitrs3
	movlw	0x20			; (35clk - 3)
	subwf	TMR0, 1
waitrs3a
	btfsc	TMR0, 7
	goto	waitrs3a
	
	movf	rxphase, 0
	addwf	rxphase, 0
	incf	rxphase, 1
	
	addwf	PCL, 1
	
		; 0:start
	btfsc	PORTA, PORTA_RX
	clrf	rxphase
	
	retlw	0
	nop
	
	retlw	0
	nop
		; 3:bit0
	clrf	rxwork
	retlw	0
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 0
	
	retlw	0
	nop
		; 6:bit1
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 1
	
	retlw	0
	nop
		; 9:bit2
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 2
	
	retlw	0
	nop
		; 12:bit3
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 3
	
	retlw	0
	nop
		; 15:bit4
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 4
	
	retlw	0
	nop
		; 18:bit5
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 5
	
	retlw	0
	nop
		; 21:bit6
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 6
	
	retlw	0
	nop
		; 24:bit7
	retlw	0
	nop
	
	btfsc	PORTA, PORTA_RX
	bsf	rxwork, 7
	
	retlw	0
	nop
		; 27:stop
	movf	rxwork, 0
	movwf	rxdata
	clrf	rxphase
	retlw	0


sendrs_hex
	movwf	work1
	
	call	waitrs
	
	swapf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
	call	sendrs
	
	movf	work1, 0
	andlw	0xf
	addlw	0xf6			; 0xa -> 0x100
	btfsc	STATUS, C
	addlw	0x27			; 0xa -> 0x27 -> 0x61
	addlw	0x3a			; 0x9 -> 0xff -> 0x39
sendrs
	movwf	txdata
	bcf	PORTA, PORTA_TX		; start
	nop
	nop
	call	waitrs
	btfsc	txdata, 0		; LSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 0
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 1		; bit 1
	bsf	PORTA, PORTA_TX
	btfss	txdata, 1
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 2		; bit 2
	bsf	PORTA, PORTA_TX
	btfss	txdata, 2
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 3		; bit 3
	bsf	PORTA, PORTA_TX
	btfss	txdata, 3
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 4		; bit 4
	bsf	PORTA, PORTA_TX
	btfss	txdata, 4
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 5		; bit 5
	bsf	PORTA, PORTA_TX
	btfss	txdata, 5
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 6		; bit 6
	bsf	PORTA, PORTA_TX
	btfss	txdata, 6
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	btfsc	txdata, 7		; MSB
	bsf	PORTA, PORTA_TX
	btfss	txdata, 7
	bcf	PORTA, PORTA_TX
	
	call	waitrs
	nop
	nop
	bsf	PORTA, PORTA_TX		; stop
	call	waitrs
	retlw	0


clraddr
	clrf	addr
	clrf	addr + 1
	clrf	addr + 2
	clrf	addr + 3
	retlw	0

getaddr				; [FSR] <- mmc_packet
	movwf	FSR
	
	movf	mmc_packet + 1, 0
	movwf	INDF
	incf	FSR, 1
	
	movf	mmc_packet + 2, 0
	movwf	INDF
	incf	FSR, 1
	
	movf	mmc_packet + 3, 0
	movwf	INDF
	incf	FSR, 1
	
	movf	mmc_packet + 4, 0
	movwf	INDF
	
	retlw	0

setaddr				; mmc_packet <- [FSR]
	movwf	FSR
	
	movf	INDF, 0
	movwf	mmc_packet + 1
	incf	FSR, 1
	
	movf	INDF, 0
	movwf	mmc_packet + 2
	incf	FSR, 1
	
	movf	INDF, 0
	movwf	mmc_packet + 3
	incf	FSR, 1
	
	movf	INDF, 0
	movwf	mmc_packet + 4
	
	retlw	0

addaddr				; mmc_packet += [FSR]
	movwf	FSR
	
	movlw	3
	addwf	FSR, 1
	
	movf	INDF, 0
	addwf	mmc_packet + 4, 1
	movlw	1
	btfsc	STATUS, C
	addwf	mmc_packet + 3, 1
	btfsc	STATUS, C
	addwf	mmc_packet + 2, 1
	btfsc	STATUS, C
	addwf	mmc_packet + 1, 1
	
	decf	FSR, 1
	
	movf	INDF, 0
	addwf	mmc_packet + 3, 1
	movlw	1
	btfsc	STATUS, C
	addwf	mmc_packet + 2, 1
	btfsc	STATUS, C
	addwf	mmc_packet + 1, 1
	
	decf	FSR, 1
	
	movf	INDF, 0
	addwf	mmc_packet + 2, 1
	btfsc	STATUS, C
	incf	mmc_packet + 1, 1
	
	decf	FSR, 1
	
	movf	INDF, 0
	addwf	mmc_packet + 1, 1
	
	retlw	0


cluster2addr			; cluster to addr
	call	clraddr
	movf	cur_cluster, 0
	movwf	addr + 1
	movlw	0xfe			; -2 : offset
	addwf	cur_cluster + 1, 0
	movwf	addr + 2
	btfss	STATUS, C
	decf	addr + 1, 1
	
	movlw	1
	movwf	remain_sec
	
	movf	c_hsecp, 0
	movwf	work0
cluster2addr_loop
	bcf	STATUS, C
	rlf	addr + 2, 1		; addr = cur_cluster << (c_hsecp + 8)
	rlf	addr + 1, 1
	rlf	addr + 0, 1
	bcf	STATUS, C
	rlf	remain_sec, 1		; remain_sec = 1 << c_hsecp
	decfsz	work0, 1
	goto	cluster2addr_loop
	
	bcf	STATUS, C
	rrf	remain_sec, 1		; remain_sec = 1 << (c_hsecp - 1)
	movf	remain_sec, 1
	btfsc	STATUS, Z
	bsf	remain_sec, 7		; remain_sec = 80h
	
	movlw	useraddr
	call	setaddr
	
	movlw	addr
	goto	addaddr


mmcstart
	bcf	PORTA, PORTA_MMCCS
	retlw	0


mmcstop
	bsf	PORTB, PORTB_MMCDI
	movlw	8
	movwf	bitcount
mmcstop_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	bitcount, 1
	goto	mmcstop_loop
	
	bsf	PORTA, PORTA_MMCCS
	
	movlw	8
	movwf	bitcount
mmcstop_loop2
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	bitcount, 1
	goto	mmcstop_loop2
	retlw	0


mmccmd
	movlw	6
	movwf	bytecount
	movlw	mmc_packet
	movwf	FSR
mmccmd_loop
	movf	INDF, 0
	call	mmcwrite
	
	incf	FSR, 1
	decfsz	bytecount, 1
	goto	mmccmd_loop
mmccmd_loop2
	call	mmcread
	btfsc	mmc_packet, 7
	goto	mmccmd_loop2
	retlw	0			; card ready


waitread			; wait for data-packet start byte
waitread_loop
	call	mmcread
	
	movf	mmc_packet, 0
	xorlw	0xff
	btfsc	STATUS, Z
	goto	waitread_loop		; card busy
	
	movf	mmc_packet, 0
	xorlw	0xfe			; data-start
	btfss	STATUS, Z
	goto	waitread_loop
	retlw	0


waitwrite
waitwrite_loop
	call	mmcread
	movf	mmc_packet, 0
	andlw	0x1f
	xorlw	5
	btfss	STATUS, Z		; data-packet receive complete
	goto	waitwrite_loop
waitwrite_loop2
	call	mmcread
	movf	mmc_packet, 0
	btfsc	STATUS, Z
	goto	waitwrite_loop2		; card busy
	
	retlw	0


mmcread
	movlw	8
	movwf	bitcount
mmcread_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bcf	STATUS, C
	btfsc	PORTB, PORTB_MMCDO
	bsf	STATUS, C
	
	rlf	mmc_packet, 1
	
	decfsz	bitcount, 1
	goto	mmcread_loop
	
	retlw	0


mmcwrite
	movwf	mmc_packet
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 7
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 6
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 5
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 4
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 3
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 2
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 1
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	btfss	mmc_packet, 0
	bcf	PORTB, PORTB_MMCDI
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	
	bsf	PORTB, PORTB_MMCDI
	retlw	0


displayerror42
	movlw	0x42
displayerror
	movwf	work2
	movlw	0x65		; 'e'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x6f		; 'o'
	call	sendrs
	movlw	0x72		; 'r'
	call	sendrs
	movlw	0x3d		; '='
	call	sendrs
	movf	work2, 0
	call	sendrs_hex
	movlw	0xd			; CR
	call	sendrs
	movlw	0xa			; LF
	call	sendrs
	
displayerror_halt
	goto	displayerror_halt


mmc_init
	clrf	mmc_packet
	clrf	mmc_packet + 1
	clrf	mmc_packet + 2
	clrf	mmc_packet + 3
	clrf	mmc_packet + 4
	clrf	mmc_packet + 5
reset0
	movlw	0x50			; reset : 80clk
	movwf	work0
reset0_loop
	bcf	PORTB, PORTB_MMCCK
	bsf	PORTB, PORTB_MMCCK
	decfsz	work0, 1
	goto	reset0_loop
	
	call	mmcstart
	movlw	0x40			; cmd0
	movwf	mmc_packet
	movlw	0x95			; crc
	movwf	mmc_packet + 5
	call	mmccmd
	movlw	0xff
	movwf	mmc_packet + 5
	call	mmcstop
	
	movf	mmc_packet, 0
	xorlw	1
	movlw	0x11			; cmd0 failed
	btfss	STATUS, Z
	goto	displayerror
reset1
	call	wait250ms
	
	call	mmcstart
	movlw	0x41			; cmd1
	movwf	mmc_packet
	call	mmccmd
	call	mmcstop
	
	movf	mmc_packet, 0
	xorlw	1			; 1: card busy
	btfsc	STATUS, Z
	goto	reset1
	
	movf	mmc_packet, 0
	movlw	0x12			; cmd1 failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcstart
	movlw	0x50			; set_blocklen
	movwf	mmc_packet
	clrf	mmc_packet + 1
	clrf	mmc_packet + 2
	movlw	2
	movwf	mmc_packet + 3		; 200h = 512bytes / sector
	clrf	mmc_packet + 4
	call	mmccmd
	clrf	mmc_packet + 3
	call	mmcstop
	
	movf	mmc_packet, 0
	movlw	0x13			; set_blocklen failed
	btfss	STATUS, Z
	goto	displayerror
	
getmbr
	call	mmcstart
	movlw	0x51			; read single block
	movwf	mmc_packet
	clrf	mmc_packet + 1		; MBR
	clrf	mmc_packet + 2
	clrf	mmc_packet + 3
	clrf	mmc_packet + 4
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	0x31			; MBR read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	movlw	0xe3			; skip 1c6h bytes
	movwf	work0
getmbr_loop1
	call	mmcread
	call	mmcread
	decfsz	work0, 1
	goto	getmbr_loop1
	
	call	mmcread			; off = 1c6h: sector number of first partition
	movf	mmc_packet, 0
	movwf	mmc_packet + 3
	call	mmcread			; off = 1c7h
	movf	mmc_packet, 0
	movwf	mmc_packet + 2
	call	mmcread			; off = 1c8h
	movf	mmc_packet, 0
	movwf	mmc_packet + 1
	call	mmcread			; off = 1c9h
	
	bcf	STATUS, C
	rlf	mmc_packet + 3, 1	; addr = sector_number << 9
	rlf	mmc_packet + 2, 1
	rlf	mmc_packet + 1, 1
	
	movlw	0x34			; skip 34h bytes
	movwf	work0
getmbr_loop2
	call	mmcread
	decfsz	work0, 1
	goto	getmbr_loop2
	
	call	mmcread			; off = 1feh
	movf	mmc_packet, 0
	xorlw	0x55
	movlw	0x32			; MBR signature error
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcread			; off = 1ffh
	movf	mmc_packet, 0
	xorlw	0xaa
	movlw	0x32			; MBR signature error
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcread			;CRC
	call	mmcread
	call	mmcstop
	
getpbr
	call	mmcstart
	movlw	0x51			; read single block
	movwf	mmc_packet
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	0x41			; PBR read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	movlw	0xd			; skip 0dh bytes
	movwf	work0
getpbr_loop1
	call	mmcread
	decfsz	work0, 1
	goto	getpbr_loop1
	
	call	mmcread			; off = 0dh: half-sector(256 bytes)s / cluster
	clrf	c_hsecp
	
getpbr_powcnt
	incf	c_hsecp, 1
	bcf	STATUS, C
	rrf	mmc_packet, 1
	movf	mmc_packet, 1
	btfss	STATUS, Z
	goto	getpbr_powcnt
	
	movlw	8			; skip 8 bytes
	movwf	work0
getpbr_loop2
	call	mmcread
	decfsz	work0, 1
	goto	getpbr_loop2
	
	call	mmcread			; off = 16h
	movf	mmc_packet, 0
	movwf	f_sec
	
	movlw	0x1f			; skip 1fh bytes
	movwf	work0
getpbr_loop3
	call	mmcread
	decfsz	work0, 1
	goto	getpbr_loop3
	
	call	mmcread			; off = 36h
	movf	mmc_packet, 0
	xorlw	0x46			; 'F'
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 37h
	movf	mmc_packet, 0
	xorlw	0x41			; 'A'
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 38h
	movf	mmc_packet, 0
	xorlw	0x54			; 'T'
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 39h
	movf	mmc_packet, 0
	xorlw	0x31			; '1'
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 3ah
	movf	mmc_packet, 0
	xorlw	0x36			; '6'
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 3bh
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 3ch
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	displayerror42
	
	call	mmcread			; off = 3dh
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	displayerror42
	
getpbr_h
	movlw	0xe0			; skip 1c0h bytes
	movwf	work0
getpbr_h_loop3
	call	mmcread
	call	mmcread
	
	decfsz	work0, 1
	goto	getpbr_h_loop3
	
	call	mmcread			; off = 1feh
	movf	mmc_packet, 0
	xorlw	0x55
	movlw	0x43			; PBR signature error
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcread			; off = 1ffh
	movf	mmc_packet, 0
	xorlw	0xaa
	movlw	0x43			; PBR signature error
	btfss	STATUS, Z
	goto	displayerror
	
	call	mmcread			;CRC
	call	mmcread
	call	mmcstop
	
	call	clraddr
	movlw	2			; size of PBR
	movwf	addr + 2
	
	movlw	addr
	call	addaddr
	
	movlw	fataddr			; fataddr = PBR + size of PBR
	call	getaddr
	
	call	clraddr
	movf	f_sec, 0
	movwf	addr + 2
	
	bcf	STATUS, C
	rlf	addr + 2, 1		; RDE = fataddr + 0x200 * 2 * f_sec
					; 2 FATs exist on disk
	rlf	addr + 1, 1
	bcf	STATUS, C
	rlf	addr + 2, 1
	rlf	addr + 1, 1
	
	movlw	addr
	call	addaddr
	
	movlw	rdeaddr
	call	getaddr
	
	call	clraddr
	movlw	0x40			; size of RDE
	movwf	addr + 2
	
	movlw	addr
	call	addaddr
	
	movlw	useraddr		; useraddr = RDE + size of RDE
	call	getaddr
	retlw	0


mmc_fopen
	movlw	rdeaddr
	call	setaddr
getrde
	call	mmcstart
	movlw	0x51			; read single block
	movwf	mmc_packet
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	0x51			; RDE read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	clrf	cur_cluster		; cur_cluster = 0: not found
	clrf	cur_cluster + 1
	
	movlw	0x10			; 10h entries / sector
	movwf	work0
	
getrde_loop1
	movlw	0x20			; 20h bytes / sector
	movwf	work1
	
	movf	cur_cluster, 0
	iorwf	cur_cluster + 1, 0
	btfss	STATUS, Z
	goto	getrde_next		; cur_cluster already set
	
	call	mmcread			; off = 0
	decf	work1, 1
	
	movf	mmc_packet, 1
	movlw	0x52			; end of RDE
	btfsc	STATUS, Z
	goto	displayerror		; first byte = 0
	
	movf	mmc_packet, 0
	xorlw	0x4c			; 'L'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 1
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x4f			; 'O'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 2
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x47			; 'G'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 3
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 4
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 5
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 6
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 7
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x20			; ' '
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 8
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x54			; 'T'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 9
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x58			; 'X'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 0ah
	decf	work1, 1
	
	movf	mmc_packet, 0
	xorlw	0x54			; 'T'
	btfss	STATUS, Z
	goto	getrde_next
	
	call	mmcread			; off = 0bh
	decf	work1, 1
	
	movf	mmc_packet, 0
	andlw	0x1f			; DIR | VOL | HID | SYS | RO
	btfss	STATUS, Z
	goto	getrde_next
	
getrde_find
	movlw	0xe
	movwf	work1
getrde_loop2
	call	mmcread
	
	decfsz	work1, 1
	goto	getrde_loop2
	
	call	mmcread			; off = 1ah
	movf	mmc_packet, 0
	movwf	cur_cluster + 1
	
	call	mmcread			; off = 1bh
	movf	mmc_packet, 0
	movwf	cur_cluster
	
	movlw	4
	movwf	work1
getrde_next				; to next entry
	call	mmcread
	
	decfsz	work1, 1
	goto	getrde_next
	
	decfsz	work0, 1
	goto	getrde_loop1
	
	call	mmcread			; CRC
	call	mmcread
	call	mmcstop
	
	movf	cur_cluster, 0
	iorwf	cur_cluster + 1, 0
	movlw	0x53			; LOG.TXT not found
	btfsc	STATUS, Z
	goto	displayerror
	
cluster_loop
	call	cluster2addr
	
	call	clraddr
	movlw	2			; 200h per sector
	movwf	addr + 2
	
	retlw	0


mmc_fillsector
	movwf	work1
	
mmc_fillsector0
	movf	rem_byte + 1, 0
	iorwf	rem_byte, 0
	btfsc	STATUS, Z
	goto	mmc_fillsector1
	
	movf	work1, 0
	call	mmcwrite
	
	movlw	0xff
	addwf	rem_byte + 1, 1
	btfss	STATUS, C
	decf	rem_byte, 1
	
	goto	mmc_fillsector0
	
mmc_fillsector1
	call	mmcwrite		; CRC-1
	call	mmcwrite		; CRC-2
	call	waitwrite
	call	mmcstop
	
	retlw	0


mmc_next
	movlw	addr
	call	addaddr
	
	decfsz	remain_sec, 1
	retlw	0
	
nextcluster
	call	clraddr			; cluster to FAT-addr
	movf	cur_cluster, 0
	movwf	addr + 2
	
	bcf	STATUS, C
	rlf	addr + 2, 1
	rlf	addr + 1, 1
	
	movlw	fataddr
	call	setaddr
	
	movlw	addr
	call	addaddr
	
	call	mmcstart
	movlw	51h			; read single block
	movwf	mmc_packet
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	71h			; FAT read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	movf	cur_cluster + 1, 0	; skip FAT entry
	movwf	work1
	btfsc	STATUS, Z
	goto	nextcluster_exit2
	movwf	work0
nextcluster_loop2
	call	mmcread
	call	mmcread
	
	decfsz	work0, 1
	goto	nextcluster_loop2
nextcluster_exit2
	call	mmcread
	movf	mmc_packet, 0
	movwf	cur_cluster + 1
	call	mmcread
	movf	mmc_packet, 0
	movwf	cur_cluster
	
	movf	work1, 0		; skip till end of sector
	xorlw	0ffh
	btfsc	STATUS, Z
	goto	nextcluster_exit3
	movwf	work0
nextcluster_loop3
	call	mmcread
	call	mmcread
	
	decfsz	work0, 1
	goto	nextcluster_loop3
nextcluster_exit3
	call	mmcread			;CRC
	call	mmcread
	call	mmcstop
	
	movf	cur_cluster, 1
	btfss	STATUS, Z
	goto	nextcluster_check
	movf	cur_cluster + 1, 0
	andlw	0feh
	btfss	STATUS, Z
	goto	nextcluster_check
	
	movlw	72h		; cluster-0 or 1 found in FAT-chain
				; (may overwrite FAT)
	goto	displayerror
nextcluster_check
	movlw	1
	addwf	cur_cluster, 0
	btfss	STATUS, C
	goto	cluster_loop	; < 0ff00h
	movlw	9
	addwf	cur_cluster + 1, 0
	btfsc	STATUS, Z
	goto	nextcluster_bad	; == 0fff7h
	btfss	STATUS, C
	goto	cluster_loop
	
	retlw	1			; EOF
	
nextcluster_bad
	movlw	73h
	goto	displayerror


measure_mark
	clrf	work1
measure_mark_loop
	btfsc	PORTA, PORTA_IR
	retlw	0
	
	call	waitrs
	incf	work1, 1
	btfsc	STATUS, Z
	decf	work1, 1
	goto	measure_mark_loop


measure_space
	clrf	work1
measure_space_loop
	btfss	PORTA, PORTA_IR
	retlw	0
	
	call	waitrs
	incf	work1, 1
	btfss	STATUS, Z
	goto	measure_space_loop
	
	decf	work1, 1
	retlw	0


init
	clrf	PORTA			; PORTA: 00000000
	clrf	PORTB			; PORTB: 00000000
	
	bsf	STATUS, RP0
	
	movlw	0x11			; PORTA: OOOIOOOI
	movwf	PORTA
	movlw	1
	movwf	PORTB			; PORTB: OOOOOOOI
	movlw	0xf			; RBPU TMR=1MHz
	movwf	OPTION_REG & 0x7f
	
	bcf	STATUS, RP0
	
	movlw	7			; PORTA: digital-input
	movwf	CMCON
	
	clrf	crlf
	clrf	rxphase
	clrf	rxwork
	clrf	rxdata
	
	bsf	PORTA, PORTA_MMCCS
	bsf	PORTB, PORTB_MMCDI
	bsf	PORTB, PORTB_MMCCK
	
	bcf	PORTA, PORTA_RST
	bsf	PORTA, PORTA_TX		; LED
	call	wait250ms
	bsf	PORTA, PORTA_RST
	
	call	mmc_init
main
	call	mmc_fopen
sector_loop
	call	mmcstart
	movlw	0x58			; write block
	movwf	mmc_packet
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	0x61			; data write failed
	btfss	STATUS, Z
	goto	displayerror
	
	movlw	0xff			; dummy data
	call	mmcwrite
	movlw	0xfe			; data start
	call	mmcwrite
	
	movlw	2			; remain bytes = 200h
	movwf	rem_byte
	clrf	rem_byte + 1
recvloop
wait_start
	call	waitrs
	btfsc	crlf, 2
	goto	http_main
	btfsc	PORTA, PORTA_IR
	goto	wait_start
	
	call	measure_mark
check_start
	movf	work1, 0
	addlw	0x80
	btfss	STATUS, C
	goto	wait_start		; mark < 12.8ms
	
	call	measure_space
	movf	work1, 0
	addlw	0x40
	btfsc	STATUS, C
	goto	wait_start		; space > 19.2ms
	addlw	0x80
	btfss	STATUS, C
	goto	wait_start		; space < 6.4ms
	
bit0
	clrf	count
	
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 0		; space < 1.0ms
	
bit1
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 1		; space < 1.0ms
	
bit2
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 2		; space < 1.0ms
	
bit3
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 3		; space < 1.0ms
	
bit4
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 4		; space < 1.0ms
	
bit5
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 5		; space < 1.0ms
	
bit6
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 6		; space < 1.0ms
	
bit7
	call	measure_mark
	movf	work1, 0
	addlw	0xf6
	btfsc	STATUS, C
	goto	recvexit		; mark > 1.0ms
	
	call	measure_space
	movf	work1, 0
	addlw	0xe2
	btfsc	STATUS, C
	goto	recvexit		; space > 3.0ms
	addlw	0x14
	btfss	STATUS, C
	bsf	count, 7		; space < 1.0ms
	
	movf	count, 0
	call	mmcwrite		; about 44 clks
	
	movlw	0xff
	addwf	rem_byte + 1, 1
	btfss	STATUS, C
	decf	rem_byte, 1
	
	movf	rem_byte + 1, 0
	iorwf	rem_byte, 0
	btfss	STATUS, Z
	goto	bit0
recvexit
	movlw	0xff
	call	mmc_fillsector
	call	wait250ms		; LED-off
	call	wait250ms
	
	call	mmc_next
	iorlw	0
	btfsc	STATUS, Z
	goto	sector_loop
					; EOF
	goto	main


http_main
	movlw	0
	call	mmc_fillsector
	
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
	movlw	0x48			; 'H'
	call	sendrs
	movlw	0x54			; 'T'
	call	sendrs
	movlw	0x54			; 'T'
	call	sendrs
	movlw	0x50			; 'P'
	call	sendrs
	movlw	0x2f			; '/'
	call	sendrs
	movlw	0x31			; '1'
	call	sendrs
	movlw	0x2e			; '.'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x20			; ' '
	call	sendrs
	movlw	0x32			; '2'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x30			; '0'
	call	sendrs
	movlw	0x20			; ' '
	call	sendrs
	movlw	0x4f			; 'O'
	call	sendrs
	movlw	0x4b			; 'K'
	call	sendrs
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	movlw	0xd
	call	sendrs
	movlw	0xa
	call	sendrs
	
	call	mmc_fopen
http_sector_loop
	call	mmcstart
	movlw	51h		; read single block
	movwf	mmc_packet
	call	mmccmd
	
	movf	mmc_packet, 0
	movlw	61h		; data read failed
	btfss	STATUS, Z
	goto	displayerror
	
	call	waitread
	
	clrf	work2		; 512bytes
	call	waitrs
	call	waitrs
	call	waitrs
	call	waitrs
readchar_loop
	call	mmcread
	call	waitrs
	movf	mmc_packet, 0
	call	sendrs_hex
	movlw	0x20
	call	sendrs
	
	call	mmcread
	call	waitrs
	movf	mmc_packet, 0
	call	sendrs_hex
	movlw	0x20
	call	sendrs
	
	decfsz	work2, 1
	goto	readchar_loop
	
	movf	mmc_packet, 0
	movwf	work0
	
	call	mmcread		;CRC
	call	mmcread
	call	mmcstop
	
	movf	work0, 0
	btfsc	STATUS, Z
	goto	http_main_exit
	
	call	mmc_next
	iorlw	0
	btfsc	STATUS, Z
	goto	http_sector_loop
http_main_exit
					; EOF
	clrf	crlf
	call	wait250ms		; LED-off
	call	mmcstart
	call	wait250ms		; LED-on
	call	mmcstop
	call	wait250ms		; LED-off
	goto	main


	end
